/// <reference types="lodash" />
import { IListState, IMovie, IMovieList, IPeople, IPeopleList, LanguageTypes, PaginationWrapper } from 'interfaces';
declare type List = IPeopleList | IMovieList;
declare type StateList = IListState<List>;
declare const wrapperState: () => [StateList | null, (f: StateList | ((draft: StateList | {
    list: {
        results: import("immer").DraftArray<IMovie[]>;
        page: number;
        total_results: number;
        total_pages: number;
    } | {
        results: import("immer").DraftArray<IPeople[]>;
        page: number;
        total_results: number;
        total_pages: number;
    };
    searchQuery: string;
    hasMore: boolean;
    selectedId: number | null;
    isLoading: boolean;
} | null) => void) | null) => void];
interface IProps {
    state: StateList;
    language?: LanguageTypes;
    filter?: IMovie | IPeople | null;
    onSelect?(widget: IMovie | IPeople | null): void;
    loadList(params: {
        page: number;
        query?: string;
        resetFilter?: boolean;
    }): void;
    scrollTop(position: number): void;
    setState: ReturnType<typeof wrapperState>[1];
}
export declare const useListLoad: (props: IProps) => {
    handleUpdateState: (dataList: PaginationWrapper<any>, isNewList: boolean) => void;
    handleSelect: (widget: IMovie | IPeople | null) => () => void;
    handleSearch: import("lodash").DebouncedFunc<(query: string) => void>;
    loadMoreData: () => Promise<void>;
};
export {};
