function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var ReactDOM = _interopDefault(require('react-dom'));
var uuid = require('uuid');
var merge = _interopDefault(require('lodash.merge'));
var useImmer = require('use-immer');
var debounce = _interopDefault(require('lodash.debounce'));
var clsx = _interopDefault(require('clsx'));
var i18n = _interopDefault(require('i18next'));
var axios = _interopDefault(require('axios'));

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var styles = {"widgetWrapper":"_3C1m6","widgetTitle":"_3ZvKA","widgetList":"_2uAiR","widgetListScroll":"_2pU97","widgetCard":"_3TjLL","widgetCardWrapper":"_39i6p","widgetCardActive":"_2mxin","widgetCardTitle":"_3HNPT","widgetCardRating":"_e3Vv8","widgetCardPoster":"_2bdwc","widgetCardPosterEmpty":"_3WlnO","widgetCardRatingTitle":"_3ibgL","widgetCardRatingProgress":"_3naoh","widgetCardRatingProgressBar":"_3RA0b","widgetCardRatingText":"_2iGGY"};

var MOVIE_API_PATH = 'https://api.themoviedb.org/3';
var MOVIE_IMAGE_PATH = 'https://image.tmdb.org/t/p';

var getImagePath = function getImagePath(path) {
  return MOVIE_IMAGE_PATH + "/w500" + path;
};
var getPersentage = function getPersentage(value) {
  return value * 10;
};

var filterListItem = function filterListItem(query) {
  return function (item) {
    if (!query) return true;
    var searchField = item.title ? item.title : item.name;
    return searchField.toLowerCase().indexOf(query.toLowerCase()) > -1;
  };
};

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var defineProperty = createCommonjsModule(function (module) {
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

module.exports = _defineProperty;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

var _defineProperty = unwrapExports(defineProperty);

var classCallCheck = createCommonjsModule(function (module) {
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

module.exports = _classCallCheck;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

var _classCallCheck = unwrapExports(classCallCheck);

var createClass = createCommonjsModule(function (module) {
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

module.exports = _createClass;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

var _createClass = unwrapExports(createClass);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultOptions = {
  bindI18n: 'languageChanged',
  bindI18nStore: '',
  transEmptyNodeValue: '',
  transSupportBasicHtmlNodes: true,
  transKeepBasicHtmlNodesFor: ['br', 'strong', 'i', 'p'],
  useSuspense: true
};
var i18nInstance;
var I18nContext = React__default.createContext();
function setDefaults() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  defaultOptions = _objectSpread(_objectSpread({}, defaultOptions), options);
}
function getDefaults() {
  return defaultOptions;
}
var ReportNamespaces = function () {
  function ReportNamespaces() {
    _classCallCheck(this, ReportNamespaces);

    this.usedNamespaces = {};
  }

  _createClass(ReportNamespaces, [{
    key: "addUsedNamespaces",
    value: function addUsedNamespaces(namespaces) {
      var _this = this;

      namespaces.forEach(function (ns) {
        if (!_this.usedNamespaces[ns]) _this.usedNamespaces[ns] = true;
      });
    }
  }, {
    key: "getUsedNamespaces",
    value: function getUsedNamespaces() {
      return Object.keys(this.usedNamespaces);
    }
  }]);

  return ReportNamespaces;
}();
function setI18n(instance) {
  i18nInstance = instance;
}
function getI18n() {
  return i18nInstance;
}
var initReactI18next = {
  type: '3rdParty',
  init: function init(instance) {
    setDefaults(instance.options.react);
    setI18n(instance);
  }
};

function warn() {
  if (console && console.warn) {
    var _console;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (typeof args[0] === 'string') args[0] = "react-i18next:: ".concat(args[0]);

    (_console = console).warn.apply(_console, args);
  }
}
var alreadyWarned = {};
function warnOnce() {
  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  if (typeof args[0] === 'string' && alreadyWarned[args[0]]) return;
  if (typeof args[0] === 'string') alreadyWarned[args[0]] = new Date();
  warn.apply(void 0, args);
}
function loadNamespaces(i18n, ns, cb) {
  i18n.loadNamespaces(ns, function () {
    if (i18n.isInitialized) {
      cb();
    } else {
      var initialized = function initialized() {
        setTimeout(function () {
          i18n.off('initialized', initialized);
        }, 0);
        cb();
      };

      i18n.on('initialized', initialized);
    }
  });
}
function hasLoadedNamespace(ns, i18n) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!i18n.languages || !i18n.languages.length) {
    warnOnce('i18n.languages were undefined or empty', i18n.languages);
    return true;
  }

  var lng = i18n.languages[0];
  var fallbackLng = i18n.options ? i18n.options.fallbackLng : false;
  var lastLng = i18n.languages[i18n.languages.length - 1];
  if (lng.toLowerCase() === 'cimode') return true;

  var loadNotPending = function loadNotPending(l, n) {
    var loadState = i18n.services.backendConnector.state["".concat(l, "|").concat(n)];
    return loadState === -1 || loadState === 2;
  };

  if (options.bindI18n && options.bindI18n.indexOf('languageChanging') > -1 && i18n.services.backendConnector.backend && i18n.isLanguageChangingTo && !loadNotPending(i18n.isLanguageChangingTo, ns)) return false;
  if (i18n.hasResourceBundle(lng, ns)) return true;
  if (!i18n.services.backendConnector.backend) return true;
  if (loadNotPending(lng, ns) && (!fallbackLng || loadNotPending(lastLng, ns))) return true;
  return false;
}

var arrayWithHoles = createCommonjsModule(function (module) {
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

module.exports = _arrayWithHoles;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

unwrapExports(arrayWithHoles);

var iterableToArrayLimit = createCommonjsModule(function (module) {
function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

module.exports = _iterableToArrayLimit;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

unwrapExports(iterableToArrayLimit);

var arrayLikeToArray = createCommonjsModule(function (module) {
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

module.exports = _arrayLikeToArray;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

unwrapExports(arrayLikeToArray);

var unsupportedIterableToArray = createCommonjsModule(function (module) {
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
}

module.exports = _unsupportedIterableToArray;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

unwrapExports(unsupportedIterableToArray);

var nonIterableRest = createCommonjsModule(function (module) {
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

module.exports = _nonIterableRest;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

unwrapExports(nonIterableRest);

var slicedToArray = createCommonjsModule(function (module) {
function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}

module.exports = _slicedToArray;
module.exports["default"] = module.exports, module.exports.__esModule = true;
});

var _slicedToArray = unwrapExports(slicedToArray);

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function useTranslation(ns) {
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var i18nFromProps = props.i18n;

  var _ref = React.useContext(I18nContext) || {},
      i18nFromContext = _ref.i18n,
      defaultNSFromContext = _ref.defaultNS;

  var i18n = i18nFromProps || i18nFromContext || getI18n();
  if (i18n && !i18n.reportNamespaces) i18n.reportNamespaces = new ReportNamespaces();

  if (!i18n) {
    warnOnce('You will need to pass in an i18next instance by using initReactI18next');

    var notReadyT = function notReadyT(k) {
      return Array.isArray(k) ? k[k.length - 1] : k;
    };

    var retNotReady = [notReadyT, {}, false];
    retNotReady.t = notReadyT;
    retNotReady.i18n = {};
    retNotReady.ready = false;
    return retNotReady;
  }

  if (i18n.options.react && i18n.options.react.wait !== undefined) warnOnce('It seems you are still using the old wait option, you may migrate to the new useSuspense behaviour.');

  var i18nOptions = _objectSpread$1(_objectSpread$1(_objectSpread$1({}, getDefaults()), i18n.options.react), props);

  var useSuspense = i18nOptions.useSuspense;
  var namespaces = ns || defaultNSFromContext || i18n.options && i18n.options.defaultNS;
  namespaces = typeof namespaces === 'string' ? [namespaces] : namespaces || ['translation'];
  if (i18n.reportNamespaces.addUsedNamespaces) i18n.reportNamespaces.addUsedNamespaces(namespaces);
  var ready = (i18n.isInitialized || i18n.initializedStoreOnce) && namespaces.every(function (n) {
    return hasLoadedNamespace(n, i18n, i18nOptions);
  });

  function getT() {
    return i18n.getFixedT(null, i18nOptions.nsMode === 'fallback' ? namespaces : namespaces[0]);
  }

  var _useState = React.useState(getT),
      _useState2 = _slicedToArray(_useState, 2),
      t = _useState2[0],
      setT = _useState2[1];

  var isMounted = React.useRef(true);
  React.useEffect(function () {
    var bindI18n = i18nOptions.bindI18n,
        bindI18nStore = i18nOptions.bindI18nStore;
    isMounted.current = true;

    if (!ready && !useSuspense) {
      loadNamespaces(i18n, namespaces, function () {
        if (isMounted.current) setT(getT);
      });
    }

    function boundReset() {
      if (isMounted.current) setT(getT);
    }

    if (bindI18n && i18n) i18n.on(bindI18n, boundReset);
    if (bindI18nStore && i18n) i18n.store.on(bindI18nStore, boundReset);
    return function () {
      isMounted.current = false;
      if (bindI18n && i18n) bindI18n.split(' ').forEach(function (e) {
        return i18n.off(e, boundReset);
      });
      if (bindI18nStore && i18n) bindI18nStore.split(' ').forEach(function (e) {
        return i18n.store.off(e, boundReset);
      });
    };
  }, [i18n, namespaces.join()]);
  var isInitial = React.useRef(true);
  React.useEffect(function () {
    if (isMounted.current && !isInitial.current) {
      setT(getT);
    }

    isInitial.current = false;
  }, [i18n]);
  var ret = [t, i18n, ready];
  ret.t = t;
  ret.i18n = i18n;
  ret.ready = ready;
  if (ready) return ret;
  if (!ready && !useSuspense) return ret;
  throw new Promise(function (resolve) {
    loadNamespaces(i18n, namespaces, function () {
      resolve();
    });
  });
}

function I18nextProvider(_ref) {
  var i18n = _ref.i18n,
      defaultNS = _ref.defaultNS,
      children = _ref.children;
  var value = React.useMemo(function () {
    return {
      i18n: i18n,
      defaultNS: defaultNS
    };
  }, [i18n, defaultNS]);
  return React.createElement(I18nContext.Provider, {
    value: value
  }, children);
}

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var defaultTheme = {
  colors: {
    primary: '#007bff',
    secondary: '#6c757d',
    success: '#28a745',
    light: '#f8f9fa',
    dark: '#343a40'
  }
};

var SEARCH_DELAY_TIMER = 500;

var DEFAULT_PAGE = 1;

var listWithPaginationInitialState = function listWithPaginationInitialState() {
  return {
    results: [],
    page: DEFAULT_PAGE,
    total_pages: 1,
    total_results: 1
  };
};

var getWidgetListAction = function getWidgetListAction(api, payload) {
  try {
    var params = payload.params,
        path = payload.path;
    return Promise.resolve(_catch(function () {
      return Promise.resolve(api.get(path, {
        params: params
      })).then(function (result) {
        return result.data;
      });
    }, function () {
      return listWithPaginationInitialState();
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};
var getPeopleByMovieAction = function getPeopleByMovieAction(api, payload) {
  try {
    var params = payload.params,
        path = payload.path;
    return Promise.resolve(_catch(function () {
      return Promise.resolve(api.get(path, {
        params: params
      })).then(function (result) {
        var list = {
          results: result.data.credits.cast,
          page: DEFAULT_PAGE,
          total_results: result.data.credits.cast.length,
          total_pages: DEFAULT_PAGE
        };
        return list;
      });
    }, function () {
      return listWithPaginationInitialState();
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};
var getMoviesByPeopleAction = function getMoviesByPeopleAction(api, payload) {
  try {
    var params = payload.params,
        path = payload.path;
    return Promise.resolve(_catch(function () {
      return Promise.resolve(api.get(path, {
        params: params
      })).then(function (result) {
        var movies = result.data.results;
        var promises = [];

        for (var index = result.data.page + 1; index <= result.data.total_pages; index++) {
          var updatedParams = _extends({}, params, {
            page: index
          });

          promises.push(api.get(path, {
            params: updatedParams
          }));
        }

        return Promise.resolve(Promise.all(promises)).then(function (values) {
          var otherResults = values.sort(function (a, b) {
            return a.data.page - b.data.page;
          }).flatMap(function (v) {
            return v.data.results;
          });
          movies.push.apply(movies, otherResults);
          var list = {
            results: movies,
            page: DEFAULT_PAGE,
            total_results: movies.length,
            total_pages: DEFAULT_PAGE
          };
          return list;
        });
      });
    }, function () {
      return listWithPaginationInitialState();
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

/* eslint-disable no-undefined,no-param-reassign,no-shadow */

/**
 * Throttle execution of a function. Especially useful for rate limiting
 * execution of handlers on events like resize and scroll.
 *
 * @param  {Number}    delay          A zero-or-greater delay in milliseconds. For event callbacks, values around 100 or 250 (or even higher) are most useful.
 * @param  {Boolean}   [noTrailing]   Optional, defaults to false. If noTrailing is true, callback will only execute every `delay` milliseconds while the
 *                                    throttled-function is being called. If noTrailing is false or unspecified, callback will be executed one final time
 *                                    after the last throttled-function call. (After the throttled-function has not been called for `delay` milliseconds,
 *                                    the internal counter is reset)
 * @param  {Function}  callback       A function to be executed after delay milliseconds. The `this` context and all arguments are passed through, as-is,
 *                                    to `callback` when the throttled-function is executed.
 * @param  {Boolean}   [debounceMode] If `debounceMode` is true (at begin), schedule `clear` to execute after `delay` ms. If `debounceMode` is false (at end),
 *                                    schedule `callback` to execute after `delay` ms.
 *
 * @return {Function}  A new, throttled, function.
 */
function throttle (delay, noTrailing, callback, debounceMode) {
  /*
   * After wrapper has stopped being called, this timeout ensures that
   * `callback` is executed at the proper times in `throttle` and `end`
   * debounce modes.
   */
  var timeoutID;
  var cancelled = false; // Keep track of the last time `callback` was executed.

  var lastExec = 0; // Function to clear existing timeout

  function clearExistingTimeout() {
    if (timeoutID) {
      clearTimeout(timeoutID);
    }
  } // Function to cancel next exec


  function cancel() {
    clearExistingTimeout();
    cancelled = true;
  } // `noTrailing` defaults to falsy.


  if (typeof noTrailing !== 'boolean') {
    debounceMode = callback;
    callback = noTrailing;
    noTrailing = undefined;
  }
  /*
   * The `wrapper` function encapsulates all of the throttling / debouncing
   * functionality and when executed will limit the rate at which `callback`
   * is executed.
   */


  function wrapper() {
    var self = this;
    var elapsed = Date.now() - lastExec;
    var args = arguments;

    if (cancelled) {
      return;
    } // Execute `callback` and update the `lastExec` timestamp.


    function exec() {
      lastExec = Date.now();
      callback.apply(self, args);
    }
    /*
     * If `debounceMode` is true (at begin) this is used to clear the flag
     * to allow future `callback` executions.
     */


    function clear() {
      timeoutID = undefined;
    }

    if (debounceMode && !timeoutID) {
      /*
       * Since `wrapper` is being called for the first time and
       * `debounceMode` is true (at begin), execute `callback`.
       */
      exec();
    }

    clearExistingTimeout();

    if (debounceMode === undefined && elapsed > delay) {
      /*
       * In throttle mode, if `delay` time has been exceeded, execute
       * `callback`.
       */
      exec();
    } else if (noTrailing !== true) {
      /*
       * In trailing throttle mode, since `delay` time has not been
       * exceeded, schedule `callback` to execute `delay` ms after most
       * recent execution.
       *
       * If `debounceMode` is true (at begin), schedule `clear` to execute
       * after `delay` ms.
       *
       * If `debounceMode` is false (at end), schedule `callback` to
       * execute after `delay` ms.
       */
      timeoutID = setTimeout(debounceMode ? clear : exec, debounceMode === undefined ? delay - elapsed : delay);
    }
  }

  wrapper.cancel = cancel; // Return the wrapper function.

  return wrapper;
}

var ThresholdUnits = {
    Pixel: 'Pixel',
    Percent: 'Percent',
};
var defaultThreshold = {
    unit: ThresholdUnits.Percent,
    value: 0.8,
};
function parseThreshold(scrollThreshold) {
    if (typeof scrollThreshold === 'number') {
        return {
            unit: ThresholdUnits.Percent,
            value: scrollThreshold * 100,
        };
    }
    if (typeof scrollThreshold === 'string') {
        if (scrollThreshold.match(/^(\d*(\.\d+)?)px$/)) {
            return {
                unit: ThresholdUnits.Pixel,
                value: parseFloat(scrollThreshold),
            };
        }
        if (scrollThreshold.match(/^(\d*(\.\d+)?)%$/)) {
            return {
                unit: ThresholdUnits.Percent,
                value: parseFloat(scrollThreshold),
            };
        }
        console.warn('scrollThreshold format is invalid. Valid formats: "120px", "50%"...');
        return defaultThreshold;
    }
    console.warn('scrollThreshold should be string or number');
    return defaultThreshold;
}

var InfiniteScroll = /** @class */ (function (_super) {
    __extends(InfiniteScroll, _super);
    function InfiniteScroll(props) {
        var _this = _super.call(this, props) || this;
        _this.lastScrollTop = 0;
        _this.actionTriggered = false;
        // variables to keep track of pull down behaviour
        _this.startY = 0;
        _this.currentY = 0;
        _this.dragging = false;
        // will be populated in componentDidMount
        // based on the height of the pull down element
        _this.maxPullDownDistance = 0;
        _this.getScrollableTarget = function () {
            if (_this.props.scrollableTarget instanceof HTMLElement)
                return _this.props.scrollableTarget;
            if (typeof _this.props.scrollableTarget === 'string') {
                return document.getElementById(_this.props.scrollableTarget);
            }
            if (_this.props.scrollableTarget === null) {
                console.warn("You are trying to pass scrollableTarget but it is null. This might\n        happen because the element may not have been added to DOM yet.\n        See https://github.com/ankeetmaini/react-infinite-scroll-component/issues/59 for more info.\n      ");
            }
            return null;
        };
        _this.onStart = function (evt) {
            if (_this.lastScrollTop)
                return;
            _this.dragging = true;
            if (evt instanceof MouseEvent) {
                _this.startY = evt.pageY;
            }
            else if (evt instanceof TouchEvent) {
                _this.startY = evt.touches[0].pageY;
            }
            _this.currentY = _this.startY;
            if (_this._infScroll) {
                _this._infScroll.style.willChange = 'transform';
                _this._infScroll.style.transition = "transform 0.2s cubic-bezier(0,0,0.31,1)";
            }
        };
        _this.onMove = function (evt) {
            if (!_this.dragging)
                return;
            if (evt instanceof MouseEvent) {
                _this.currentY = evt.pageY;
            }
            else if (evt instanceof TouchEvent) {
                _this.currentY = evt.touches[0].pageY;
            }
            // user is scrolling down to up
            if (_this.currentY < _this.startY)
                return;
            if (_this.currentY - _this.startY >=
                Number(_this.props.pullDownToRefreshThreshold)) {
                _this.setState({
                    pullToRefreshThresholdBreached: true,
                });
            }
            // so you can drag upto 1.5 times of the maxPullDownDistance
            if (_this.currentY - _this.startY > _this.maxPullDownDistance * 1.5)
                return;
            if (_this._infScroll) {
                _this._infScroll.style.overflow = 'visible';
                _this._infScroll.style.transform = "translate3d(0px, " + (_this.currentY -
                    _this.startY) + "px, 0px)";
            }
        };
        _this.onEnd = function () {
            _this.startY = 0;
            _this.currentY = 0;
            _this.dragging = false;
            if (_this.state.pullToRefreshThresholdBreached) {
                _this.props.refreshFunction && _this.props.refreshFunction();
                _this.setState({
                    pullToRefreshThresholdBreached: false,
                });
            }
            requestAnimationFrame(function () {
                // this._infScroll
                if (_this._infScroll) {
                    _this._infScroll.style.overflow = 'auto';
                    _this._infScroll.style.transform = 'none';
                    _this._infScroll.style.willChange = 'unset';
                }
            });
        };
        _this.onScrollListener = function (event) {
            if (typeof _this.props.onScroll === 'function') {
                // Execute this callback in next tick so that it does not affect the
                // functionality of the library.
                setTimeout(function () { return _this.props.onScroll && _this.props.onScroll(event); }, 0);
            }
            var target = _this.props.height || _this._scrollableNode
                ? event.target
                : document.documentElement.scrollTop
                    ? document.documentElement
                    : document.body;
            // return immediately if the action has already been triggered,
            // prevents multiple triggers.
            if (_this.actionTriggered)
                return;
            var atBottom = _this.props.inverse
                ? _this.isElementAtTop(target, _this.props.scrollThreshold)
                : _this.isElementAtBottom(target, _this.props.scrollThreshold);
            // call the `next` function in the props to trigger the next data fetch
            if (atBottom && _this.props.hasMore) {
                _this.actionTriggered = true;
                _this.setState({ showLoader: true });
                _this.props.next && _this.props.next();
            }
            _this.lastScrollTop = target.scrollTop;
        };
        _this.state = {
            showLoader: false,
            pullToRefreshThresholdBreached: false,
        };
        _this.throttledOnScrollListener = throttle(150, _this.onScrollListener).bind(_this);
        _this.onStart = _this.onStart.bind(_this);
        _this.onMove = _this.onMove.bind(_this);
        _this.onEnd = _this.onEnd.bind(_this);
        return _this;
    }
    InfiniteScroll.prototype.componentDidMount = function () {
        if (typeof this.props.dataLength === 'undefined') {
            throw new Error("mandatory prop \"dataLength\" is missing. The prop is needed" +
                " when loading more content. Check README.md for usage");
        }
        this._scrollableNode = this.getScrollableTarget();
        this.el = this.props.height
            ? this._infScroll
            : this._scrollableNode || window;
        if (this.el) {
            this.el.addEventListener('scroll', this
                .throttledOnScrollListener);
        }
        if (typeof this.props.initialScrollY === 'number' &&
            this.el &&
            this.el instanceof HTMLElement &&
            this.el.scrollHeight > this.props.initialScrollY) {
            this.el.scrollTo(0, this.props.initialScrollY);
        }
        if (this.props.pullDownToRefresh && this.el) {
            this.el.addEventListener('touchstart', this.onStart);
            this.el.addEventListener('touchmove', this.onMove);
            this.el.addEventListener('touchend', this.onEnd);
            this.el.addEventListener('mousedown', this.onStart);
            this.el.addEventListener('mousemove', this.onMove);
            this.el.addEventListener('mouseup', this.onEnd);
            // get BCR of pullDown element to position it above
            this.maxPullDownDistance =
                (this._pullDown &&
                    this._pullDown.firstChild &&
                    this._pullDown.firstChild.getBoundingClientRect()
                        .height) ||
                    0;
            this.forceUpdate();
            if (typeof this.props.refreshFunction !== 'function') {
                throw new Error("Mandatory prop \"refreshFunction\" missing.\n          Pull Down To Refresh functionality will not work\n          as expected. Check README.md for usage'");
            }
        }
    };
    InfiniteScroll.prototype.componentWillUnmount = function () {
        if (this.el) {
            this.el.removeEventListener('scroll', this
                .throttledOnScrollListener);
            if (this.props.pullDownToRefresh) {
                this.el.removeEventListener('touchstart', this.onStart);
                this.el.removeEventListener('touchmove', this.onMove);
                this.el.removeEventListener('touchend', this.onEnd);
                this.el.removeEventListener('mousedown', this.onStart);
                this.el.removeEventListener('mousemove', this.onMove);
                this.el.removeEventListener('mouseup', this.onEnd);
            }
        }
    };
    InfiniteScroll.prototype.UNSAFE_componentWillReceiveProps = function (props) {
        // do nothing when dataLength is unchanged
        if (this.props.dataLength === props.dataLength)
            return;
        this.actionTriggered = false;
        // update state when new data was sent in
        this.setState({
            showLoader: false,
        });
    };
    InfiniteScroll.prototype.isElementAtTop = function (target, scrollThreshold) {
        if (scrollThreshold === void 0) { scrollThreshold = 0.8; }
        var clientHeight = target === document.body || target === document.documentElement
            ? window.screen.availHeight
            : target.clientHeight;
        var threshold = parseThreshold(scrollThreshold);
        if (threshold.unit === ThresholdUnits.Pixel) {
            return (target.scrollTop <=
                threshold.value + clientHeight - target.scrollHeight + 1);
        }
        return (target.scrollTop <=
            threshold.value / 100 + clientHeight - target.scrollHeight + 1);
    };
    InfiniteScroll.prototype.isElementAtBottom = function (target, scrollThreshold) {
        if (scrollThreshold === void 0) { scrollThreshold = 0.8; }
        var clientHeight = target === document.body || target === document.documentElement
            ? window.screen.availHeight
            : target.clientHeight;
        var threshold = parseThreshold(scrollThreshold);
        if (threshold.unit === ThresholdUnits.Pixel) {
            return (target.scrollTop + clientHeight >= target.scrollHeight - threshold.value);
        }
        return (target.scrollTop + clientHeight >=
            (threshold.value / 100) * target.scrollHeight);
    };
    InfiniteScroll.prototype.render = function () {
        var _this = this;
        var style = __assign({ height: this.props.height || 'auto', overflow: 'auto', WebkitOverflowScrolling: 'touch' }, this.props.style);
        var hasChildren = this.props.hasChildren ||
            !!(this.props.children &&
                this.props.children instanceof Array &&
                this.props.children.length);
        // because heighted infiniteScroll visualy breaks
        // on drag down as overflow becomes visible
        var outerDivStyle = this.props.pullDownToRefresh && this.props.height
            ? { overflow: 'auto' }
            : {};
        return (React__default.createElement("div", { style: outerDivStyle, className: "infinite-scroll-component__outerdiv" },
            React__default.createElement("div", { className: "infinite-scroll-component " + (this.props.className || ''), ref: function (infScroll) { return (_this._infScroll = infScroll); }, style: style },
                this.props.pullDownToRefresh && (React__default.createElement("div", { style: { position: 'relative' }, ref: function (pullDown) { return (_this._pullDown = pullDown); } },
                    React__default.createElement("div", { style: {
                            position: 'absolute',
                            left: 0,
                            right: 0,
                            top: -1 * this.maxPullDownDistance,
                        } }, this.state.pullToRefreshThresholdBreached
                        ? this.props.releaseToRefreshContent
                        : this.props.pullDownToRefreshContent))),
                this.props.children,
                !this.state.showLoader &&
                    !hasChildren &&
                    this.props.hasMore &&
                    this.props.loader,
                this.state.showLoader && this.props.hasMore && this.props.loader,
                !this.props.hasMore && this.props.endMessage)));
    };
    return InfiniteScroll;
}(React.Component));

var styles$1 = {"textWrapper":"_3NQiE","input":"_1_zpj"};

function TextInput(props) {
  var _props$type = props.type,
      type = _props$type === void 0 ? 'text' : _props$type,
      name = props.name,
      onChange = props.onChange,
      value = props.value,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '' : _props$placeholder,
      disabled = props.disabled;
  return React__default.createElement("div", {
    className: styles$1.textWrapper
  }, React__default.createElement("input", {
    disabled: disabled,
    placeholder: placeholder,
    value: value,
    name: name,
    type: type,
    className: styles$1.input,
    onChange: onChange
  }));
}

var styles$2 = {"search":"_3mHpb"};

var usePrevious = function usePrevious(value) {
  var ref = React.useRef(value);
  React.useEffect(function () {
    ref.current = value;
  });
  return ref.current;
};

var useScrollTop = function useScrollTop(ref) {
  return function (position) {
    if (ref.current) {
      var div = ref.current.getElementsByClassName('infinite-scroll-component')[0];
      div.scrollTop = position;
    }
  };
};

var useListLoad = function useListLoad(props) {
  var state = props.state,
      _props$state = props.state,
      _props$state$list = _props$state.list,
      total_pages = _props$state$list.total_pages,
      page = _props$state$list.page,
      language = props.language,
      filter = props.filter,
      setState = props.setState,
      scrollTop = props.scrollTop,
      loadList = props.loadList,
      onSelect = props.onSelect;

  var scrollToTop = function scrollToTop() {
    scrollTop(0);
  };

  var handleSelect = function handleSelect(widget) {
    return function () {
      if (!onSelect) return;
      setState(function (draft) {
        if (!draft) return;
        draft.selectedId = (widget === null || widget === void 0 ? void 0 : widget.id) || null;
      });
      onSelect(widget);
    };
  };

  var handleSearch = React.useCallback(debounce(function (query) {
    scrollToTop();
    setState(function (draft) {
      if (!draft) return;
      draft.searchQuery = query;
    });

    if (!filter) {
      loadList({
        page: DEFAULT_PAGE,
        query: query
      });
      return;
    }
  }, SEARCH_DELAY_TIMER), [language, filter === null || filter === void 0 ? void 0 : filter.id]);

  var handleUpdateState = function handleUpdateState(dataList, isNewList) {
    var hasMore = dataList.total_pages > dataList.page;
    var updatedList = dataList;

    if (updatedList.page > DEFAULT_PAGE) {
      var prevResults = isNewList ? [] : state.list.results;
      updatedList = _extends({}, dataList, {
        results: [].concat(prevResults, dataList.results)
      });
    }

    setState(function (draft) {
      if (!draft) return;
      draft.hasMore = hasMore;
      draft.list = updatedList;
      draft.isLoading = false;
    });
  };

  var loadMoreData = function loadMoreData() {
    try {
      var newPage = page + 1;

      if (newPage > total_pages) {
        setState(function (draft) {
          if (!draft) return;
          draft.hasMore = false;
        });
        return Promise.resolve();
      }

      loadList({
        page: newPage
      });
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  };

  React.useEffect(function () {
    loadList({
      page: DEFAULT_PAGE,
      query: '',
      resetFilter: true
    });
    handleSelect(null)();
    scrollToTop();
  }, [language]);
  React.useEffect(function () {
    if (filter) {
      loadList({
        page: DEFAULT_PAGE,
        query: ''
      });
      handleSelect(null)();
      scrollToTop();
    }
  }, [filter === null || filter === void 0 ? void 0 : filter.id]);
  return {
    handleUpdateState: handleUpdateState,
    handleSelect: handleSelect,
    handleSearch: handleSearch,
    loadMoreData: loadMoreData
  };
};

function Search(props) {
  var _useImmer = useImmer.useImmer(''),
      query = _useImmer[0],
      setQuery = _useImmer[1];

  var onChange = props.onChange,
      disabled = props.disabled;
  var prevQuery = usePrevious(query);

  var _useTranslation = useTranslation(),
      t = _useTranslation.t;

  React.useEffect(function () {
    if (prevQuery !== query) {
      onChange(query);
    }
  }, [query]);
  React.useEffect(function () {
    setQuery('');
  }, [onChange]);

  var handleChange = function handleChange(event) {
    setQuery(event.target.value);
  };

  return React__default.createElement("form", {
    className: styles$2.search
  }, React__default.createElement(TextInput, {
    disabled: disabled,
    name: 'search',
    onChange: handleChange,
    value: query,
    placeholder: t('searchPlaceholder')
  }));
}

var styles$3 = {"preloader":"_2THZb"};

function Preloader() {
  var _useTranslation = useTranslation(),
      t = _useTranslation.t;

  return React__default.createElement("h4", {
    className: styles$3.preloader
  }, t('loading'));
}

var withConfig = function withConfig(ChildComponent) {
  var Wrapper = function Wrapper(props) {
    var config = props.config,
        className = props.className;
    var language = config.language,
        theme = config.theme,
        i18n = config.i18n;
    var widgetRef = React.useRef(null);
    React.useEffect(function () {
      i18n.changeLanguage(language);
    }, [language]);
    React.useEffect(function () {
      var _theme$colors = theme.colors,
          colors = _theme$colors === void 0 ? {} : _theme$colors;
      Object.keys(colors).forEach(function (key) {
        if (widgetRef.current) {
          widgetRef.current.style.setProperty("--widget-" + key, colors[key]);
        }
      });
    }, [theme, theme.colors]);
    return React__default.createElement(I18nextProvider, {
      i18n: config.i18n
    }, React__default.createElement("div", {
      className: clsx(styles.widgetWrapper, className),
      ref: widgetRef
    }, React__default.createElement(ChildComponent, Object.assign({}, props))));
  };

  return Wrapper;
};

var initialState = {
  list: listWithPaginationInitialState(),
  searchQuery: '',
  hasMore: false,
  selectedId: null,
  isLoading: false
};
var moviePaths = {
  with_query: '/search/movie',
  without_query: '/movie/popular',
  with_filter: '/discover/movie'
};

function MovieWidget(props) {
  var filter = props.filter,
      onSelect = props.onSelect,
      config = props.config;

  var _useImmer = useImmer.useImmer(initialState),
      state = _useImmer[0],
      setState = _useImmer[1];

  var scrollRef = React.useRef(null);
  var scrollTop = useScrollTop(scrollRef);
  var axios = config.api,
      language = config.language;

  var _useTranslation = useTranslation(),
      t = _useTranslation.t;

  var results = state.list.results,
      searchQuery = state.searchQuery,
      hasMore = state.hasMore,
      selectedId = state.selectedId,
      isLoading = state.isLoading;

  var startLoading = function startLoading() {
    setState(function (draft) {
      draft.isLoading = true;
    });
  };

  var loadList = function loadList(_ref) {
    var page = _ref.page,
        query = _ref.query,
        resetFilter = _ref.resetFilter;

    try {
      var _temp3 = function _temp3() {
        handleUpdateState(dataList, isNewList);
      };

      var newQuery = query !== undefined ? query : searchQuery;
      var params = {
        language: language,
        page: page,
        query: newQuery
      };
      var path = Boolean(newQuery) ? moviePaths.with_query : moviePaths.without_query;
      startLoading();
      var dataList = listWithPaginationInitialState();
      var isNewList = false;

      var _temp4 = function () {
        if (!resetFilter && filter) {
          path = moviePaths.with_filter;
          params['with_people'] = filter.id;
          return Promise.resolve(getMoviesByPeopleAction(axios, {
            path: path,
            params: params
          })).then(function (_getMoviesByPeopleAct) {
            dataList = _getMoviesByPeopleAct;
            isNewList = true;
          });
        } else {
          return Promise.resolve(getWidgetListAction(axios, {
            path: path,
            params: params
          })).then(function (_getWidgetListAction) {
            dataList = _getWidgetListAction;
          });
        }
      }();

      return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(_temp3) : _temp3(_temp4));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var _useListLoad = useListLoad({
    state: state,
    filter: filter,
    language: language,
    setState: setState,
    scrollTop: scrollTop,
    loadList: loadList,
    onSelect: onSelect
  }),
      handleUpdateState = _useListLoad.handleUpdateState,
      handleSelect = _useListLoad.handleSelect,
      handleSearch = _useListLoad.handleSearch,
      loadMoreData = _useListLoad.loadMoreData;

  var title = filter ? t('movieTitleWithFilter', {
    title: filter.name
  }) : t('movieTitle');
  var filteredMovie = filter ? results.filter(filterListItem(searchQuery)) : results;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement("span", {
    className: styles.widgetTitle
  }, title), React__default.createElement(Search, {
    onChange: handleSearch
  }), React__default.createElement("div", {
    className: clsx(styles.widgetList, isLoading && styles.widgetListLoading),
    ref: scrollRef
  }, isLoading && React__default.createElement(Preloader, null), React__default.createElement(InfiniteScroll, {
    height: 500,
    className: styles.widgetListScroll,
    dataLength: filteredMovie.length,
    next: loadMoreData,
    hasMore: hasMore,
    loader: null
  }, filteredMovie.map(function (movie) {
    var title = movie.title,
        id = movie.id,
        backdrop_path = movie.backdrop_path,
        vote_average = movie.vote_average;
    return React__default.createElement(InfographicCard, {
      key: id,
      id: id,
      imagePath: backdrop_path,
      ratingPersent: getPersentage(vote_average),
      title: title,
      onClick: handleSelect(movie),
      selectedId: selectedId
    });
  }))));
}

var MovieWidget$1 = withConfig(MovieWidget);

var widgets = {
  movie: function movie(props) {
    return React__default.createElement(MovieWidget$1, Object.assign({}, props));
  },
  people: function people(props) {
    return React__default.createElement(PeopleWidget$1, Object.assign({}, props));
  }
};
var createSpesificWidget = function createSpesificWidget(widget) {
  var config = widget.config,
      type = widget.type;
  return widgets[type](config);
};

function ImagePlaceholder() {
  return React__default.createElement("div", {
    className: styles.widgetCardPosterEmpty
  }, React__default.createElement("img", {
    src: 'https://www.flaticon.com/premium-icon/icons/svg/3875/3875433.svg'
  }));
}

function InfographicCard(props) {
  var imagePath = props.imagePath,
      ratingPersent = props.ratingPersent,
      title = props.title,
      onClick = props.onClick,
      selectedId = props.selectedId,
      id = props.id;

  var _useTranslation = useTranslation(),
      t = _useTranslation.t;

  var isActive = id === selectedId;
  return React__default.createElement("div", {
    className: clsx(styles.widgetCard),
    onClick: onClick
  }, React__default.createElement("div", {
    className: clsx(styles.widgetCardWrapper, isActive && styles.widgetCardActive)
  }, React__default.createElement("span", {
    className: styles.widgetCardTitle
  }, title), React__default.createElement("div", {
    className: styles.widgetCardRating
  }, React__default.createElement("span", {
    className: styles.widgetCardRatingTitle
  }, t('list.rating')), React__default.createElement("div", {
    className: styles.widgetCardRatingProgress
  }, React__default.createElement("span", {
    className: styles.widgetCardRatingText
  }, ratingPersent), React__default.createElement("div", {
    className: styles.widgetCardRatingProgressBar,
    style: {
      width: ratingPersent + "%"
    }
  }))), imagePath ? React__default.createElement("img", {
    src: getImagePath(imagePath),
    className: styles.widgetCardPoster,
    alt: title
  }) : React__default.createElement(ImagePlaceholder, null)));
}

var initialState$1 = {
  list: listWithPaginationInitialState(),
  searchQuery: '',
  hasMore: false,
  selectedId: null,
  isLoading: false
};
var peoplePaths = {
  with_query: '/search/person',
  without_query: '/person/popular',
  with_filter: function with_filter(movie_id) {
    return "/movie/" + movie_id;
  }
};

function PeopleWidget(props) {
  var filter = props.filter,
      onSelect = props.onSelect,
      config = props.config;

  var _useImmer = useImmer.useImmer(initialState$1),
      state = _useImmer[0],
      setState = _useImmer[1];

  var scrollRef = React.useRef(null);
  var scrollTop = useScrollTop(scrollRef);
  var axios = config.api,
      language = config.language;

  var _useTranslation = useTranslation(),
      t = _useTranslation.t;

  var results = state.list.results,
      searchQuery = state.searchQuery,
      hasMore = state.hasMore,
      selectedId = state.selectedId,
      isLoading = state.isLoading;

  var startLoading = function startLoading() {
    setState(function (draft) {
      draft.isLoading = true;
    });
  };

  var loadList = function loadList(_ref) {
    var page = _ref.page,
        query = _ref.query,
        resetFilter = _ref.resetFilter;

    try {
      var _temp3 = function _temp3() {
        handleUpdateState(dataList, isNewList);
      };

      var newQuery = query !== undefined ? query : searchQuery;
      var params = {
        language: language,
        page: page,
        query: newQuery
      };
      var path = Boolean(newQuery) ? peoplePaths.with_query : peoplePaths.without_query;
      startLoading();
      var isNewList = false;
      var dataList = listWithPaginationInitialState();

      var _temp4 = function () {
        if (!resetFilter && filter) {
          path = peoplePaths.with_filter(filter.id);
          params['append_to_response'] = 'credits';
          return Promise.resolve(getPeopleByMovieAction(axios, {
            path: path,
            params: params
          })).then(function (_getPeopleByMovieActi) {
            dataList = _getPeopleByMovieActi;
            isNewList = true;
          });
        } else {
          return Promise.resolve(getWidgetListAction(axios, {
            path: path,
            params: params
          })).then(function (_getWidgetListAction) {
            dataList = _getWidgetListAction;
          });
        }
      }();

      return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(_temp3) : _temp3(_temp4));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var _useListLoad = useListLoad({
    state: state,
    filter: filter,
    language: language,
    setState: setState,
    scrollTop: scrollTop,
    loadList: loadList,
    onSelect: onSelect
  }),
      handleUpdateState = _useListLoad.handleUpdateState,
      handleSelect = _useListLoad.handleSelect,
      handleSearch = _useListLoad.handleSearch,
      loadMoreData = _useListLoad.loadMoreData;

  var title = filter ? t('peopleTitleWithFilter', {
    title: filter.title
  }) : t('peopleTitle');
  var filteredPeople = filter ? results.filter(filterListItem(searchQuery)) : results;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement("span", {
    className: styles.widgetTitle
  }, title), React__default.createElement(Search, {
    onChange: handleSearch
  }), React__default.createElement("div", {
    className: clsx(styles.widgetList, isLoading && styles.widgetListLoading),
    ref: scrollRef
  }, isLoading && React__default.createElement(Preloader, null), React__default.createElement(InfiniteScroll, {
    height: 500,
    className: styles.widgetListScroll,
    dataLength: filteredPeople.length,
    next: loadMoreData,
    hasMore: hasMore,
    loader: null
  }, filteredPeople.map(function (people) {
    var name = people.name,
        popularity = people.popularity,
        id = people.id,
        profile_path = people.profile_path;
    return React__default.createElement(InfographicCard, {
      key: id,
      id: id,
      imagePath: profile_path,
      ratingPersent: popularity,
      title: name,
      onClick: handleSelect(people),
      selectedId: selectedId
    });
  }))));
}

var PeopleWidget$1 = withConfig(PeopleWidget);

var movieTitle = "Search Movies";
var movieTitleWithFilter = "Search Movies by people: {{title}}";
var peopleTitle = "Search Peoples";
var peopleTitleWithFilter = "Search Peoples by movie: {{title}}";
var searchPlaceholder = "Enter search query";
var loading = "loading...";
var list = {
	rating: "Rating"
};
var enTranslation = {
	movieTitle: movieTitle,
	movieTitleWithFilter: movieTitleWithFilter,
	peopleTitle: peopleTitle,
	peopleTitleWithFilter: peopleTitleWithFilter,
	searchPlaceholder: searchPlaceholder,
	loading: loading,
	list: list
};

var movieTitle$1 = "Поиск Фильмов";
var movieTitleWithFilter$1 = "Поиск Фильмов с участием: {{title}}";
var peopleTitle$1 = "Поиск Людей";
var peopleTitleWithFilter$1 = "Поиск Людей по фильму: {{title}}";
var searchPlaceholder$1 = "Введите поисковый запрос";
var loading$1 = "Загрузка...";
var list$1 = {
	rating: "Рейтинг"
};
var ruTranslation = {
	movieTitle: movieTitle$1,
	movieTitleWithFilter: movieTitleWithFilter$1,
	peopleTitle: peopleTitle$1,
	peopleTitleWithFilter: peopleTitleWithFilter$1,
	searchPlaceholder: searchPlaceholder$1,
	loading: loading$1,
	list: list$1
};

var resources = {
  en: {
    translation: enTranslation
  },
  ru: {
    translation: ruTranslation
  }
};
var createLocalization = function createLocalization() {
  var newInstance = i18n.createInstance();
  newInstance.use(initReactI18next).init({
    lng: 'en',
    resources: resources
  });
  return newInstance;
};

function httpApi(_ref) {
  var apiKey = _ref.apiKey,
      baseURL = _ref.baseURL,
      handleError = _ref.handleError;
  var instance = axios.create({
    baseURL: baseURL
  });
  instance.interceptors.request.use(function (config) {
    config.params['api_key'] = apiKey;
    return config;
  });
  instance.interceptors.response.use(undefined, function (error) {
    var _error$response, _error$response$data;

    var responseMsg = ((_error$response = error.response) === null || _error$response === void 0 ? void 0 : (_error$response$data = _error$response.data) === null || _error$response$data === void 0 ? void 0 : _error$response$data.status_message) || error.message;

    if (handleError) {
      handleError(responseMsg);
    }

    return Promise.reject(error);
  });
  return instance;
}

var ProviderConfig = /*#__PURE__*/function () {
  function ProviderConfig(config) {
    var _config$theme;

    var api = httpApi({
      apiKey: config.apiKey,
      baseURL: MOVIE_API_PATH,
      handleError: config.onError
    });
    var i18n = createLocalization();
    this.config = {
      language: config.language || 'en',
      theme: {
        colors: _extends({}, defaultTheme.colors, (_config$theme = config.theme) === null || _config$theme === void 0 ? void 0 : _config$theme.colors)
      },
      api: api,
      i18n: i18n
    };
  }

  var _proto = ProviderConfig.prototype;

  _proto.updateLanguage = function updateLanguage(language) {
    this.config = _extends({}, this.config, {
      language: language
    });
  };

  _proto.updateTheme = function updateTheme(theme) {
    this.config = _extends({}, this.config, {
      theme: {
        colors: _extends({}, this.config.theme.colors, theme.colors)
      }
    });
  };

  _proto.getCongig = function getCongig() {
    return this.config;
  };

  return ProviderConfig;
}();

var WidgetProvider = function WidgetProvider(props) {
  var config = React.useMemo(function () {
    var configServise = new ProviderConfig(props);
    return configServise.getCongig();
  }, [props]);
  return props.children(config);
};
var PeopleWidgetComponent = function PeopleWidgetComponent(props) {
  return React__default.createElement(PeopleWidget$1, Object.assign({}, props));
};
var MovieWidgetComponent = function MovieWidgetComponent(props) {
  return React__default.createElement(MovieWidget$1, Object.assign({}, props));
};
var BrowserProvider = /*#__PURE__*/function () {
  function BrowserProvider(providerProps) {
    this.widgets = [];
    this.configServise = new ProviderConfig(providerProps);
  }

  var _proto = BrowserProvider.prototype;

  _proto.createListWidget = function createListWidget(props) {
    var widget = _extends({}, props, {
      id: uuid.v4()
    });

    this.widgets.push(widget);
    return widget;
  };

  _proto.removeWidget = function removeWidget(id) {
    var updatedWidgets = this.widgets.filter(function (w) {
      return w.id !== id;
    });
    this.widgets = updatedWidgets;
    var domElement = document.getElementById(id);
    domElement === null || domElement === void 0 ? void 0 : domElement.remove();
  };

  _proto.updateWidget = function updateWidget(props) {
    var updatedWidgets = this.widgets.map(function (w) {
      if (w.id === props.id) {
        return merge(w, props);
      }

      return w;
    });
    this.widgets = updatedWidgets;
    this.render();
  };

  _proto.updateLanguage = function updateLanguage(language) {
    this.configServise.updateLanguage(language);
    this.render();
  };

  _proto.updateTheme = function updateTheme(theme) {
    this.configServise.updateTheme(theme);
    this.render();
  };

  _proto.render = function render() {
    var widgets = this.widgets;
    var config = this.configServise.getCongig();

    for (var i = 0; i < widgets.length; i += 1) {
      var widget = widgets[i];
      var component = createSpesificWidget(widget);
      var widgetElement = React__default.cloneElement(component, {
        config: config
      });
      ReactDOM.render(React__default.createElement("div", {
        id: widget.id,
        key: widget.id
      }, widgetElement), document.getElementById(widget.insertId));
    }
  };

  return BrowserProvider;
}();

exports.BrowserProvider = BrowserProvider;
exports.MovieWidgetComponent = MovieWidgetComponent;
exports.PeopleWidgetComponent = PeopleWidgetComponent;
exports.WidgetProvider = WidgetProvider;
//# sourceMappingURL=index.js.map
