/// <reference types="react" />
import { IMovie, IPeople, ITheme, LanguageTypes } from 'interfaces';
export declare enum WidgetTypes {
    MOVIE = "movie",
    PEOPLE = "people"
}
export interface IWidgetProvider {
    apiKey: string;
    theme?: ITheme;
    language?: LanguageTypes;
    children: React.ReactElement;
    onError?(err: string): void;
}
export interface IListWrapperProps<T, V> {
    filter?: T | null;
    onClick?(filter: V | null): void;
    className?: string;
}
export interface IBrowserWidget {
    type: WidgetTypes;
    id: number;
    config: IListWrapperProps<IPeople, IMovie> | IListWrapperProps<IMovie, IPeople>;
}
export interface IBrowserProvider extends IWidgetProvider {
    insertId: string;
}
export interface IBrowserListWrapperProps<T, V> {
    insertId: string;
    config: IListWrapperProps<T, V>;
}
